/*
 * @Author: daidai
 * @Date: 2021-12-23 11:18:37
 * @LastEditors: Please set LastEditors
 * @LastEditTime: 2022-04-28 15:10:45
 * @FilePath: \web-pc\src\api\modules\index.js
 */
import * as API from "../api";

export const paramType = {
    'big1': "/cpt/bigVis/company/type/list", //企业分类统计
    'big2': "/cpt/bigVis/company/online/list", //报备企业统计
    'big3': "/cpt/bigVis/company/todo/msg", //设备提醒
    'big4': "/cpt/bigVis/company/trace/list", //报警次数
    'big5': '/cpt/bigVis/task/filter',//实时预警
    'big6': '/bigscreen/installationPlan',// 安装计划
    'big7': '/cpt/bigVis/company/product/list',// 企业维护UDI产品数量
    'big8': '/cpt/bigVis/city/company',// //中间地图
    'nmapCount': '/cpt/bigVis/nmap/total',
    'productCategory': '/cpt/bigVis/nmap/category',   //产品分类统计
    'corpNmapProduct': "/cpt/bigVis/nmap/corp",
    'amapFlow': '/cpt/bigVis/amap/flow/list',
    'udiTrace': "/udi/trace/source/search",
    'recordResult': "/udi/trace/record/result",
    'product': "/udi/basic/rel/filter",
    'offlineCorp': "/cpt/bigVis/corp/offline",
    "regCorpList": "/admin/auth/register/list",  //注册企业列表
    "cplbMonitor": "/bigVis/import/cpfl/list",  //获取重点监控品种产品数量
    "corpInvList": "/bigVis/import/corp/inv/list",  //获取重点监控品种产品数量
    "corpProductList": "/udi/basic/rel/filter",           //获取企业产品
    "traceList": "/udi/trace/record/filter",           //获取追溯查询日志列表
    "warnMsg": "/bigVis/warn/msg/list",           //获取预警信息列表
    "adverseMsg": "/bigVis/adverse/msg/list",           //获取不良事件列表
    "companyBusTypeStat": "/udi/basic/company/bussinessType/stat",           //根据企业类型查询产品汇总
    "companyOnlineCheckStat": "/admin/auth/online/check/list",   //现场检查
    "onlineCheckStat": "/udi/basic/online/check/stat",
    "monthStatList": "/bigVis/month/stat/list",
    'getNetworkFirmCount': '/bigVis/import/corp/inv/getNetworkFirmCount',//获取入网企业填报情况


}
/******************      通用增删改查       ********************* */
/**
 * 通用列表
 * @param {*} param
 */
export const currentList = (key, param) => {
    return API.GET(paramType[key] + "/list", param)
}
export const currentPage = (key, param) => {
    return API.GET(paramType[key] + "/page", param)
}
/**
 * 查询可选择的列表
 * @param {*} param
 */
export const currentSelectList = (key, param) => {
    return API.GET(paramType[key] + "/selectList", param)
}


/**
 * 通用新增
 * @param {*} param
 */
export const currentSave = (key, param) => {
    return API.POST(paramType[key] + "/save", param)
}
/**
 * 通用修改
 * @param {*} param
 */
export const currentUpdate = (key, param) => {
    return API.POST(paramType[key] + "/update", param)
}

/**
 * 通用删除
 * @param {*} param
 */
export const currentDelete = (key, param) => {
    return API.POST(paramType[key] + "/delete", param)
}

/**
 * 通用获取所有不分页
 * @param {*} param
 */
export const currentSelect = (key, param) => {
    return API.GET(paramType[key] + "/select", param)
}

/**
 * 通用GET
 * @param {*} param
 */
export const currentGET = (key, param) => {
    return API.GET(paramType[key], param)
}
/**
 * 通用POST
 * @param {*} param
 */
export const currentPOST = (key, param) => {
    return API.POST(paramType[key], param)
}
// 通用接口集合
export const currentApi = {
    currentList,
    currentPage,
    currentSave,
    currentUpdate,
    currentDelete,
    currentSelect,
    currentSelectList,
    currentPOST,
    currentGET
}
